<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.0a (rvision 42126)
#									########################
#					Dvelopp pour Thelia_multi
#						Version : 1.4.2
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						26/12/2012
#						Contact : support@payzen.eu
#
#####################################################################################################

include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
include_once(realpath(dirname(__FILE__)) . "/config.php");

// Rcuprer l'url du site
$variable_loader = new Variable();
$variable_loader->charger("urlsite");
$urlsite = $variable_loader->valeur;
$urlsite = (substr($urlsite,-1)=="/") ? $urlsite : $urlsite."/";	// lors des tests sur certaines config, urlsite n'avait pas de /  la fin

$variable_loader->charger("nomsite");
$nomsite = $variable_loader->valeur;


$fields = array(
	array(	"label" => "INFORMATIONS SUR LE MODULE",
			"type" => "title"
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_DEVELOPPED_BY",
			"value" => '<a href="http://www.lyra-network.com/" target="_blank">Lyra network</a>',
			"label" => "D&eacute;velopp&eacute; par",					
			"type" => "fixed"
		),
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_CONTACT",
			"value" => "support@payzen.eu",
			"label" => "Courriel de contact",
			"type" => "fixed"
	),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_CONTRIB",
			"value" => "1.0a",
			"label" => "Version du module",
			"type" => "fixed"
	),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_GATEWAY",
			"value" => "V1",
			"label" => "Version de la plateforme",
			"type" => "fixed"
	),
		
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_CMS",
			"value" => "Thelia 1.4.2",
			"label" => "Test&eacute; avec",
			"type" => "fixed"
		),

//------------------- Gateway access -------------------
	array(	"label" => "ACC&Egrave;S &Agrave; LA PLATEFORME",
			"type" => "title"
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_SITE_ID",
			"default" => "12345678",
			"label" => "Identifiant de votre site",
			"type" => "text"
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_KEY_TEST",
			"default" => "1111111111111111",
			"label" => "Certificat en mode test",		
			"type" => "text"
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_KEY_PROD",
			"default" => "2222222222222222",
			"label" => "Certificat en mode production",					
			"type" => "text"
	),
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_CTX_MODE", 
			"default" => "TEST",
			"label" => "Mode de fonctionnement",
			"type" => "radio",
			"options" => array("TEST", "PRODUCTION")
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_URL_BANK",
			"default" => "https://secure.payzen.eu/vads-payment/",
			"label" => "Url de la page de paiement",
			"type" => "text"
	),

//-------------------- Payment page --------------------------

	array(	"label" => "PAGE DE PAIEMENT",	
			"type" => "title"
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_LANG", 				
			"label" => "Langue",		
			"default" => 'fr',
			"type" => "select",
			"options" =>array(	'fr' => 'Fran&ccedil;ais',
								'en' => 'Anglais',
								'es' => 'Espagnol',
								'de' => 'Allemand',
								'it' => 'Italien',
								'zh' => 'Chinois',
								'ja' => 'Japonais',
								'pt' => 'Portugais',
								'nl' => 'N&eacute;erlandais')
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_DELAY",
			"default" => "",
			"label" => "D&eacute;lai avant remise en banque",	
			"type" => "text"
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_VALIDATION_MODE",
			"default" => '',
			"label" => "Mode de validation",
			"type" => "select",
			"options" => array(	'' => 'Par d&eacute;faut',
								'0' => 'Automatique',
								'1' => 'Manuel'
								)
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_CARDS",
			"default" => "",
			"label" => "Types de carte",
			"type" => "text"
	),
	
//---------------- Restrictions sur le montant ----------------
	array(	"label" => "RESTRICTIONS SUR LE MONTANT",
			"type" => "title"
	),
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_AMOUNT_MIN",
			"default" => "",
			"label" => "Montant minimum",
			"type" => "text"
	),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_AMOUNT_MAX",
			"default" => "",
			"label" => "Montant maximum",
			"type" => "text"
	),
	
//----------------------- Multi payment ---------------------	

	array(	"label" => "PAIEMENT MULTIPLE",
			"type" => "title"
	),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_XTIMECARD",
			"default" => "3",
			"label" => "Nombre d'&eacute;ch&eacute;ances",
			"type" => "text"
	),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_PERIOD",
			"default" => "30",
			"label" => "D&eacute;lai entre chaque paiement",
			"type" => "text"
		),

	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_FIRST_PAYMENT",
			"default" => "50",
			"label" => "Premier versement",
			"type" => "text"
		),	

//----------------------- Return options ---------------------

	array(	"label" => "RETOUR &Agrave; LA BOUTIQUE",
			"type" => "title"
	),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_REDIRECT_ENABLED",
			"default" => "false",
			"label" => "Redirection automatique",	
			"type" => "select",
			"options" => array(	'true' => 'Activ&eacute;e',
								'false' => 'D&eacute;sactiv&eacute;e')
	),
		
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_REDIRECT_SUCCESS_TIMEOUT", 	
			"default" => "5",
			"label" => "Temps avant redirection (succ&egrave;s)",
			"type" => "text"
		),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_REDIRECT_SUCCESS_MESSAGE",
		 	"default" => "Paiement accept&eacute;, vous allez tre redirig&eacute; dans quelques instants",
			"label" => "Message avant redirection (succ&egrave;s)",
			"type" => "text"
		),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_REDIRECT_ERROR_TIMEOUT", 	
			"default" => "5",
			"label" => "Temps avant redirection (&eacute;chec)",
			"type" => "text"
		),
	
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_REDIRECT_ERROR_MESSAGE", 
			"default" => "Un probl&egrave;me est survenu, vous allez tre redirig&eacute; dans quelques instants",
			"label" => "Message avant redirection (&eacute;chec)",	
			"type" => "text"
		),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_RETURN_MODE",
			"default" => "GET",
			"label" => "Mode de retour",	
			"type" => "select",
			"options" => array(	'GET' => 'GET',
								'POST' => 'POST')
	),
	
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_URL_DEFAULT", 			
			"default" => $urlsite."client/plugins/vads_multi/confirmation.php",
			"label" => "URL de retour &agrave; la boutique",	
			"type" => "text"
		),
		
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_SEND_MAIL_MODE", 			"default" => "BEFORE",
			"label" => "Envoi de mail de notification au client",				"type" => "select",
			"options" => array(
					"BEFORE" => "Avant le paiement",
					"AFTER" => "Aprs le paiement"
		)),
		
	array(	"name" => "MODULE_PAYMENT_VADS_MULTI_URL_CHECK",
			"value" => $urlsite."client/plugins/vads_multi/confirmation.php",
			"label" => "Url serveur &agrave; renseigner dans le back office PayZen",			
			"type" => "fixed"
	)

);

function generate_config($input)
{
	//TODO pas dramatique (utilisateur admin) : filtrer les donnes du formulaire
	global $fields;
	
	$conf_file = realpath(dirname(__FILE__)) . "/config.php";
	$f_socket = fopen($conf_file,"w");
	if($f_socket === false)
		die("Impossible d'ouvrir le fichier $conf_file en &eacute;criture. V&eacute;rifiez que votre serveur dispose des droits n&eacute;cessaires.");
	fwrite($f_socket,"<?php\n");
	fwrite($f_socket,"#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.0a (rvision 42126)
#									########################
#					Dvelopp pour Thelia_multi
#						Version : 1.4.2
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						26/12/2012
#						Contact : support@payzen.eu
#
#####################################################################################################");
	fwrite($f_socket,"\n");
	foreach($fields as $i => $field)
	{
		if($field['type'] == 'fixed' || $field['type'] == 'title') {
			continue;
		}
		
		$default = defined($field['name']) ? constant($field['name']) : $field['default'];
		$value = array_key_exists($field['name'], $input) ? $input[$field['name']] : $default;
		$value = ($field['type']=='text') ? addslashes($value) : $value;
		$fields[$i]['value'] = $value; // $fields[$i] is the real thing, $field is just a copy (php foreach mechanism)
		fwrite($f_socket,"define('".$field['name']."', '".$value."');\n");
	}
	fwrite($f_socket,"?>");
}

generate_config($_POST);

// Inclusion du fichier de conf tout juste gnr
include_once(realpath(dirname(__FILE__)) . "/config.php");
?>
<div id="contenu_int">
	<form action="" method="post">
	<fieldset style="margin : 5px; background-color: white;">
		<legend>Param&eacute;trage du module de paiement PayZen - paiement multiple</legend>
		<?php
		foreach($fields as $field)
		{
			if($field['type'] == 'title') {
				echo '<br /><h3 style="text-align: center;">' . $field['label'] . '</h3><br />';
			} else {
				$value = $field['value'];
					
				// Label
				echo '<label style="width:250px; display:block; float:left; margin-right:20px;text-align:right;">'.$field["label"].'</label>';
				
				// Input
				echo '<div style="display:block; float:left;">';
				switch ($field['type']) {
					case 'text':
						echo '<input type="text" name="'.$field['name'].'" value="'.$value.'" size="75"/>';
						break;
							
					case 'radio':
						foreach($field['options'] as $option)
						{
							echo '<input type="radio" name="'.$field['name'].'" value="'.$option.'"';
							echo ($value==$option) ? ' checked="checked"' : '';
							echo ' />';
							echo $option."&nbsp;&nbsp;";
						}
						break;
							
					case 'select':
						echo '<select name="'.$field['name'].'" >';
						foreach ($field['options'] as $key => $label)
						{
							echo '<option value="' . $key . '"' . ($key == $value ? 'selected="selected"' : '') .  '>';
							echo $label;
							echo '</option>';
						}
						echo ' </select>';
						break;
							
					default:
						echo $value;
					break;
				}
				echo '</div>';
					
				// css clear
				echo '<div style="clear:both; height:0.5em;"></div>';
			}
		}
		?>
		<br/>
		<input type="submit" value="Valider" />
	</fieldset>
	</form>
</div>