<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.0a (rvision 42126)
#									########################
#					Dvelopp pour Thelia_multi
#						Version : 1.4.2
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						26/12/2012
#						Contact : support@payzen.eu
#
#####################################################################################################

include_once(realpath(dirname(__FILE__)) . "/config.php");
include_once(realpath(dirname(__FILE__)) . "/vads_multi_api.php");
include_once("../../../classes/Navigation.class.php");
include_once("../../../classes/Variable.class.php");
include_once("../../../classes/Devise.class.php");


session_start();



/* Initialisation des paramtres de la commande */
	$total = 0;
	$total = $_SESSION['navig']->panier->total(1, $_SESSION['navig']->commande->remise) + $_SESSION['navig']->commande->port;
	$total = round($total, 2);
	$total *= 100;
	
	$client = $_SESSION['navig']->client;
	
	$currency = 'EUR';
	
	if($_SESSION['navig']->commande->devise != 0 ){
		$devise = new Devise();
		$reference = $_SESSION['navig']->commande->devise;
		$devise->charger($reference);
		$currency = $devise->code ;
	}
	
	$cust_id = $client->id;
	$cust_name = $client->nom;
	$cust_address = $client->adresse1;
	$cust_zip = $client->cpostal;
	$cust_city = $client->ville;
	//$cust_country = $client->pays;	// Thelia n'utilise pas les codes ISO 3166
	$cust_email = $client->email;
	
	$order_id=$_SESSION['navig']->commande->ref;
		
	/* Prparation de l'envoi  la plateforme de paiement */
	$vad_object = new VADS_MULTI_API();
	$vad_object->set('platform_url',MODULE_PAYMENT_VADS_MULTI_URL_BANK);
	$vad_object->set('version','V1');
	$vad_object->set('key_test',MODULE_PAYMENT_VADS_MULTI_KEY_TEST);
	$vad_object->set('key_prod',MODULE_PAYMENT_VADS_MULTI_KEY_PROD);
	$vad_object->set('amount',$total);
	$vad_object->set('capture_delay',MODULE_PAYMENT_VADS_MULTI_DELAY);
	$vad_object->set('currency',$vad_object->convertAlphaCurrency($currency));
	// cast info 
	$vad_object->set('cust_email',$cust_email);
	$vad_object->set('cust_id',$cust_id);
	$vad_object->set('cust_name',$cust_name);
	$vad_object->set('cust_address',$cust_address);
	$vad_object->set('cust_zip',$cust_zip);
	$vad_object->set('cust_city',$cust_city);
	//$vad_object->set('cust_country',$cust_country);//TODO thelia n'utilise pas les codes pays standard
	
	$vad_object->set('ctx_mode',MODULE_PAYMENT_VADS_MULTI_CTX_MODE);
	$vad_object->set('payment_cards',MODULE_PAYMENT_VADS_MULTI_CARDS);
	$vad_object->set('site_id',MODULE_PAYMENT_VADS_MULTI_SITE_ID);
	$vad_object->set('validation_mode',MODULE_PAYMENT_VADS_MULTI_VALIDATION_MODE);
	
	$vad_object->set('language',MODULE_PAYMENT_VADS_MULTI_LANG);
	$vad_object->set('order_id',$order_id);
	$vad_object->set('url_return',MODULE_PAYMENT_VADS_MULTI_URL_DEFAULT);
	$vad_object->set('contrib','Thelia_multi1.4.2_1.0a');
	$vad_object->set('redirect_enabled',MODULE_PAYMENT_VADS_MULTI_REDIRECT_ENABLED);
	$vad_object->set('return_mode',MODULE_PAYMENT_VADS_MULTI_RETURN_MODE);
	$vad_object->set('redirect_success_timeout',MODULE_PAYMENT_VADS_MULTI_REDIRECT_SUCCESS_TIMEOUT);
	$vad_object->set('redirect_success_message',utf8_encode(MODULE_PAYMENT_VADS_MULTI_REDIRECT_SUCCESS_MESSAGE));
	$vad_object->set('redirect_error_timeout',MODULE_PAYMENT_VADS_MULTI_REDIRECT_ERROR_TIMEOUT);
	$vad_object->set('redirect_error_message',utf8_encode(MODULE_PAYMENT_VADS_MULTI_REDIRECT_ERROR_MESSAGE));
//------------------------------------- Multi payment -------------------------------
	$count = MODULE_PAYMENT_VADS_MULTI_XTIMECARD;
	
	$period = MODULE_PAYMENT_VADS_MULTI_PERIOD;
	$first = (MODULE_PAYMENT_VADS_MULTI_FIRST_PAYMENT!='')? 
		 	round( (MODULE_PAYMENT_VADS_MULTI_FIRST_PAYMENT/100) * $total ): 
			round($total/$count);

	$vad_object->setMultiPayment($total, $first, $count, $period);


// Affichage du formulaire avec envoi javascript immdiat
?>
<html>
<head>
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="Expires" content="-1">
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />
<title>Redirection vers la plateforme de PayZen - Paiement multiple </title>
</head>
<body onload="document.forms[0].submit()">
<!--<p>Vous allez tre redirig vers la plateforme de paiement dans quelques instants.
Si la redirection ne fonctionne pas automatiquement, cliquez sur le bouton envoyer.</p>-->
<?php echo $vad_object->getRequestHtmlForm('name="formvads"');?>
<script type="text/javascript">document.forms[0].style.display='none';</script>
</body>
</html>